import java.awt.*;
import java.applet.*;
import java.lang.*;
import java.net.*;
import java.awt.event.*;

class DisplayArea extends Canvas implements MouseListener,MouseMotionListener
{
int max=100,beeps=0;
Color bgColor,fgColor,msColor,privColor,yellColor;
String[] Buffer;
byte[] BFlags;
String Line;
int topptr=0,botptr=0,bsize=0,scrollval,lastbsize=0;
int lines,columns,spacin,spacing,scrollbarSize;
Font myFont;
FontMetrics fm;
Graphics gg;
Image OffScreen;
int myBar_value;
int myBar_buffered;
int fontsize;
String font;
Image backgroundImage=null;
Panel logoPanel;
Color scrollbarColor;
List userList;
int hebrew=0;
int mouseMotion=0,barx,bary,barl,mouseValue;
Applet myApplet;

/* links shit */
String[] Links;
int[] LinksStart;
int[] LinksEnd;

  public DisplayArea()
  {
    Buffer=new String[max];
    BFlags=new byte[max];

    Links=new String[max];
    LinksStart=new int[max];
    LinksEnd=new int[max];

    hebrew=0;

    addMouseListener(this);
    addMouseMotionListener(this);
  }

  public void setup()
  {
  int r=0;

    gg=this.getGraphics();

    myFont=new Font(font,Font.BOLD,fontsize);
    gg.setFont(myFont);

    fm=gg.getFontMetrics();
    spacing=fm.getHeight();
    scrollbarSize=14;
    myBar_buffered=0;
    myBar_value=0;
  }

  public void recalc()
  {
  Dimension d;

    gg=OffScreen.getGraphics();
    myFont=new Font(font,Font.BOLD,fontsize);
    gg.setFont(myFont);
    fm=gg.getFontMetrics();
    spacing=fm.getHeight();
    d=this.getSize();
    lines=d.height/spacing;
    ScrollRecalc(1);
  }

  public String getUrl(String myString, int s)
  {
  int t;

    t=myString.indexOf(" ",s);

    if (t==-1)
    { return myString.substring(s); }
      else
    { return myString.substring(s,t); }
  }

  public int AddText(String myString, int loggedin)
  {
  Dimension d;
  int r,spc,last,t,k;
  byte sflag=0;
  String longLink;

    k=1;
    d=this.getSize();
    longLink=null;

    if (myString.trim().length()>0)
    {
      if (loggedin==0)
      { 
        if (myString.startsWith(">> ")) k=2; 
      }
        else
      if (myString.startsWith("+[") && userList!=null)
      {
        myString=myString.substring(1).trim();
        userList.add(myString);
        repaint();
        return 0;
      }
        else
      if (myString.startsWith("@") && userList!=null)
      {
        userList.removeAll();
        return 0;
      }
        else
      if (myString.startsWith("-[") && userList!=null)
      {
        try { userList.remove(myString.substring(1).trim()); }
        catch (Exception e) { }
        repaint();

        return 0;
      }

      if (myString.charAt(0)=='>') sflag=1;
        else
      if (myString.charAt(0)=='<') 
      {
        sflag=2; 
        if (beeps!=0) System.out.println((char)7);
      }
        else
      if (myString.charAt(0)=='#') sflag=3;
        else
      if (myString.charAt(0)=='-') sflag=4;
    }
  
    while(myString.length()>0)
    {
      if (fm.stringWidth(myString)<d.width-scrollbarSize || sflag==4)
      {
        r=myString.indexOf("http://");
        if (r>=0 || longLink!=null)
        {
          if (longLink!=null)
          {
            Links[topptr]=longLink;
            LinksStart[topptr]=fm.stringWidth("  ");
            r=myString.trim().indexOf(" ");
            if (r<0) r=myString.trim().length();
            LinksEnd[topptr]=fm.stringWidth(myString.substring(0,r+1))+LinksStart[topptr];
            if (LinksEnd[topptr]>d.width-scrollbarSize)
            { LinksEnd[topptr]=d.width-scrollbarSize-3; }
          }
            else
          {
            Links[topptr]=getUrl(myString,r);
            LinksStart[topptr]=fm.stringWidth(myString.substring(0,r));
            LinksEnd[topptr]=fm.stringWidth(Links[topptr])+LinksStart[topptr];
            if (LinksEnd[topptr]>d.width-scrollbarSize)
            { LinksEnd[topptr]=d.width-scrollbarSize-3; }
          }
        }
          else
        {
          Links[topptr]=null;
          LinksStart[topptr]=-1;
        }
        AddLine(myString,sflag);
        break;
      } 

      r=myString.length()-1;
      
      while(r>=0 && 
            fm.stringWidth(myString.substring(0,r))>d.width-scrollbarSize)
      { r--; }

      spc=r; last=0;
      last=myString.lastIndexOf(' ',r);

      if (last==-1) 
      { last=r; }
        else
      {
        for (spc=last; spc>=0; spc--) 
        { 
          if (myString.charAt(spc)!=' ') break;
        }

        if (spc==-1) last=r;
      }

      r=myString.substring(0,last).indexOf("http://");
      if (r>=0 && fm.stringWidth(myString.substring(0,r))<d.width-scrollbarSize)
      {
        Links[topptr]=getUrl(myString,r);
        LinksStart[topptr]=fm.stringWidth(myString.substring(0,r));
        LinksEnd[topptr]=fm.stringWidth(Links[topptr])+LinksStart[topptr];
        if (LinksEnd[topptr]>d.width-scrollbarSize)
        {
          LinksEnd[topptr]=d.width-scrollbarSize-3;
          longLink=Links[topptr];
        }
      }
        else
      {
        Links[topptr]=null;
        LinksStart[topptr]=-1;
      }

      AddLine(myString.substring(0,last),sflag);
      myString="  "+myString.substring(last).trim();
    }

    return k;
  }

  public void AddLine(String myString,byte flags)
  {
    BFlags[topptr]=flags;
    Buffer[topptr++]=myString;

    if(topptr==max) topptr=0;

    ScrollRecalc(0);
  }

  public void ScrollRecalc(int i)
  {
/* recalculate scrollbar size */

/* max is maximum number of lines */
/* bsize the current number of text lines in buffer (including on screen) */
/* lastbsize the last bsize */
/* lines is the number of visible text lines on the screen */

    if (i==0 && bsize<max) bsize++;
    myBar_buffered=bsize-lines;
    if (myBar_buffered<0) myBar_buffered=0;
    myBar_value=0;
  }

  public void paint(Graphics ggReal)
  {
  Dimension d;
  int r,l;
  int ptr,offset;
  Graphics ggButtons;

    d=this.getSize();
    if (OffScreen==null)
    {
      OffScreen=createImage(d.width,d.height);
      gg=OffScreen.getGraphics();
    }
    
    gg.setColor(bgColor);
    gg.setFont(myFont);
    gg.fillRect(0,0,d.width,d.height);
    l=0;

    if (backgroundImage!=null)
    {
      gg.drawImage(backgroundImage,
                   (d.width/2)-(backgroundImage.getWidth(null)/2),
                   (d.height/2)-(backgroundImage.getHeight(null)/2),null);
    }

    lines=d.height/spacing;
    if (bsize<=lines) { offset=0; }
      else
    { offset=myBar_value; }

    ptr=topptr-lines-offset;
    while (ptr<0) ptr=ptr+max;

    for (r=0; r<lines; r++)
    {
      if (ptr==topptr)
      { r=9000; }
        else
      {
        if (Buffer[ptr]!=null)
        {
          if (Buffer[ptr].length()>0)
          {
            if (BFlags[ptr]==1) { gg.setColor(msColor); }
              else
            if (BFlags[ptr]==2) { gg.setColor(privColor); }
              else
            if (BFlags[ptr]==3) { gg.setColor(yellColor); }
              else
            { gg.setColor(fgColor); } 
          }
            else
          { gg.setColor(fgColor); } 
          l=l+spacing;

          if (hebrew==1)
          { gg.drawString(Buffer[ptr],d.width-scrollbarSize-3-fm.stringWidth(Buffer[ptr]),l); }
            else
          {
            gg.drawString(Buffer[ptr],3,l);
            if (LinksStart[ptr]!=-1) gg.drawLine(LinksStart[ptr],l,LinksEnd[ptr],l);
          }

        }
        if (++ptr==max) ptr=0;
      }
    }

    gg.setColor(Color.darkGray);
    gg.fillRect(d.width-scrollbarSize,0,scrollbarSize,d.height);
    gg.setColor(scrollbarColor);
    l=d.height-(myBar_buffered*2);
    gg.fillRect(d.width-scrollbarSize+2,((myBar_buffered-myBar_value)*2)+2,
              scrollbarSize-3,l-3);
    ggReal.drawImage(OffScreen,0,0,null);
  }

  public int convHex(String DaHex)
  {
  char m,l;
  byte msb,lsb;

    DaHex=DaHex.toLowerCase();
    m=DaHex.charAt(0);
    l=DaHex.charAt(1);
    if (m>='0' && m<='9') { msb=(byte)(m-'0'); }
      else
    if (m>='a' && m<='f') { msb=(byte)(m-'a'+10); }
      else
    { msb=0; }

    if (l>='0' && l<='9') { lsb=(byte)(l-'0'); }
      else
    if (l>='a' && l<='f') { lsb=(byte)(l-'a'+10); }
      else
    { lsb=0; }

    return msb*16+lsb;
  }

  public Color convColor(String DisColor)
  {
  int r,g,b;

    if (DisColor==null) return null;
    if (DisColor.length()==0) return null;

    r=convHex(DisColor.substring(1,3));
    g=convHex(DisColor.substring(3,5));
    b=convHex(DisColor.substring(5,7));
    return new Color(r,g,b);
  }

  public void mousePressed(MouseEvent evt) 
  {
  Dimension d;
  int x,y;
  int r,l;
  int offset,ptr;

    x=evt.getX();
    y=evt.getY();

    barx=this.getSize().width-scrollbarSize;
    barl=this.getSize().height;

    /* if ((x>barx && x<scrollbarSize) && (y>0 && y<barl)) */
    if (x>barx)
    {
      if (y<(myBar_buffered-myBar_value)*2)
      {
        myBar_value+=lines;

        if (myBar_value>=myBar_buffered-1) 
        { myBar_value=myBar_buffered-1; }

        /* paint(gg); */
        repaint();
      } 
        else
      if (y>(barl-(myBar_value*2)))
      {
        myBar_value-=lines;
        if (myBar_value<0) myBar_value=0;

        repaint();
      } 
        else
      {
        mouseMotion=y;
        mouseValue=myBar_value;
      }
    }
      else
    {
      l=0;
      d=this.getSize();

      lines=d.height/spacing;
      if (bsize<=lines) { offset=0; }
        else
      { offset=myBar_value; }

      ptr=topptr-lines-offset;
      while (ptr<0) ptr=ptr+max;

      for (r=0; r<lines; r++)
      {
        if (ptr==topptr)
        { r=9000; }
          else
        {
          if (Buffer[ptr]!=null)
          {
            l=l+spacing;
            if (LinksStart[ptr]!=-1)
            if (y>l-10 && y<=l)
            {
              if (x>=LinksStart[ptr] && x<=LinksEnd[ptr])
              {
                System.out.println(Links[ptr]);
                try { myApplet.getAppletContext().showDocument(new URL(Links[ptr]),"new window"); }
                catch (Exception e) { System.out.println("Error: "+e.toString()); }
              }
            }

          }
          if (++ptr==max) ptr=0;
        }
      }

    }
  }

  public void mouseDragged(MouseEvent evt)
  {
  int l;
  int x,y;

    x=evt.getX();
    y=evt.getY();

    if (mouseMotion!=0)
    {
      if (y>0 && y<barl)
      {
        l=(int)((mouseMotion-y)/2);
        myBar_value=mouseValue+l;

        if (myBar_value<0)
        { myBar_value=0; }
          else
        if (myBar_value>=myBar_buffered-1) 
        { myBar_value=myBar_buffered-1; }

        repaint();
      }
    }
  }

  public void update(Graphics gg)
  {
    paint(gg);
  }

  public void mouseReleased(MouseEvent evt)
  {
  int x,y;

    x=evt.getX();
    y=evt.getY();

    /* if (mouseMotion==1) paint(gg); */
    if (mouseMotion==1) repaint();
    mouseMotion=0;
  }

  public void mouseEntered(MouseEvent evt) {}
  public void mouseExited(MouseEvent evt) {}
  public void mouseClicked(MouseEvent evt) {}
  public void mouseMoved(MouseEvent evt) {}

}


